#!/bin/sh
#
# cpcicreate.sh - Create /dev devices based on the major number listed
# in /proc/devices
#
# V1.0   Written by Chad Schwartz
# V1.1,  August 20 2001, PEB: Get NPORTS from /proc and create only as
#        many device nodes as we need (rather than calling createdevs).

DRIVERMAJOR=`cat /proc/devices |grep ttyCP |awk '{print $1}'`
MGMTMAJOR=`cat /proc/devices |grep cpciCtl |awk '{print $1}'`
NPORTS=`cat /proc/tty/driver/ClassicPCI |tail -1 | awk '{print $1}'`

if [ -z "$DRIVERMAJOR" -o -z "$MGMTMAJOR" ]; then
	exit
fi

# echo "Driver Major number is $DRIVERMAJOR"
# echo "Management Major number is $MGMTMAJOR"

# Let's make sure there are no /dev/ttyCP* devices installed already..
rm -f /dev/ttyCP* 1> /dev/null 2> /dev/null
rm -f /dev/cpciCtl 1> /dev/null 2> /dev/null

# Okay. Fire off the device creator.
#/etc/digicpci/createdevs $DRIVERMAJOR $MGMTMAJOR
i=0
while [ $i -lt ${NPORTS} ]
do
	mknod /dev/ttyCP$i c $DRIVERMAJOR $i
	i=$[ $i + 1 ]
done

# Control device
mknod /dev/cpciCtl c $MGMTMAJOR 0
