
typedef unsigned char uchar;

#include <termios.h>
#include "fepflags.h"
#include "fep5.h"
#include "digi.h"



/*****************************************************************
 * dxb_hpux_translate_flags()
 ****************************************************************/
void dxb_hpux_translate_flags(struct bs_struct *bs, struct digi_stat *ds)
{
  unsigned int baudrate;

  bs->iflag = 0;  
  /*Translate iflags*/
  if (ds->info_iflag & IGNBRK)
    bs->iflag |= HW_IGNBRK;

  if (ds->info_iflag & BRKINT)
    bs->iflag |= HW_BRKINT;

  if (ds->info_iflag & IGNPAR)
    bs->iflag |= HW_IGNPAR;

  if (ds->info_iflag & PARMRK)
    bs->iflag |= HW_PARMRK;

  if (ds->info_iflag & INPCK)
    bs->iflag |= HW_INPCK;

  if (ds->info_iflag & ISTRIP)
    bs->iflag |= HW_ISTRIP;

  if (ds->info_iflag & INLCR)
    bs->iflag |= HW_INLCR;

  if (ds->info_iflag & IGNCR)
    bs->iflag |= HW_IGNCR;

  if (ds->info_iflag & ICRNL)
    bs->iflag |= HW_ICRNL;

  if (ds->info_iflag & IUCLC)
    bs->iflag |= HW_IUCLC;

  if (ds->info_iflag & IXON)
    bs->iflag |= HW_IXON;

  if (ds->info_iflag & IXANY)
    bs->iflag |= HW_IXANY;
  
  if (ds->info_iflag & IXOFF)
    bs->iflag |= HW_IXOFF;

#if 0
  if (ds->info_iflag & IENQAK)
    bs->iflag |= 0;
#endif

  /*CHANGED*/
  if (ds->info_iflag & IMAXBEL)
    bs->iflag |= HW_IMAXBEL;

  bs->oflag = 0;

  /*Translate oflags*/
  if (ds->info_oflag & OPOST)
    bs->oflag |= HW_OPOST;

  if (ds->info_oflag & OLCUC)
    bs->oflag |= HW_OLCUC;

  if (ds->info_oflag & ONLCR)
    bs->oflag |= HW_ONLCR;

  if (ds->info_oflag & OCRNL)
    bs->oflag |= HW_OCRNL;

  if (ds->info_oflag & ONOCR)
    bs->oflag |= HW_ONOCR;

  if (ds->info_oflag & ONLRET)
    bs->oflag |= HW_ONLRET;

  if (ds->info_oflag & OFILL)
    bs->oflag |= HW_OFILL;

  if (ds->info_oflag & OFDEL)
    bs->oflag |= HW_OFDEL;

  if (ds->info_oflag & NLDLY)
    bs->oflag |= HW_NLDLY;

  if (ds->info_oflag & NL0)
    bs->oflag |= HW_NL0;

  if (ds->info_oflag & NL1)
    bs->oflag |= HW_NL1;

  if (ds->info_oflag & CRDLY)
    bs->oflag |= HW_CRDLY;

  if (ds->info_oflag & CR0)
    bs->oflag |= HW_CR0;

  if (ds->info_oflag & CR1)
    bs->oflag |= HW_CR1;

  if (ds->info_oflag & CR2)
    bs->oflag |= HW_CR2;

  if (ds->info_oflag & CR3)
    bs->oflag |= HW_CR3;

  if (ds->info_oflag & TABDLY)
    bs->oflag |= HW_TABDLY;

  if (ds->info_oflag & TAB1)
    bs->oflag |= HW_TAB1;

  if (ds->info_oflag & TAB2)
    bs->oflag |= HW_TAB2;

  if (ds->info_oflag & TAB3)
    bs->oflag |= HW_TAB3;

  if (ds->info_oflag & BSDLY)
    bs->oflag |= HW_BSDLY;

  if (ds->info_oflag & BS0)
    bs->oflag |= HW_BS0;

  if (ds->info_oflag & BS1)
    bs->oflag |= HW_BS1;

  if (ds->info_oflag & VTDLY)
    bs->oflag |= HW_VTDLY;

  if (ds->info_oflag & VT0)
    bs->oflag |= HW_VT0;

  if (ds->info_oflag & VT1)
    bs->oflag |= HW_VT1;

  if (ds->info_oflag & FFDLY)
    bs->oflag |= HW_FFDLY;

  if (ds->info_oflag & FF0)
    bs->oflag |= HW_FF0;

  if (ds->info_oflag & FF1)
    bs->oflag |= HW_FF1;

  bs->cflag = 0;

  /*cflags*/

  /*CHANGE*/
  if (ds->info_cflag & EXTA)
    bs->cflag |= 0;

  /*CHANGE*/
  if (ds->info_cflag & EXTB)
    bs->cflag |= 0;
  
  /*CHANGE*/
  if (ds->info_cflag & CLOCAL)
    bs->cflag |= HW_CLOCAL;

  /*CHANGE*/
  if (ds->info_cflag & CREAD)
    bs->cflag |= HW_CREAD;

  /*CHANGE*/
  if ((ds->info_cflag & CSIZE) == CS5)
    bs->cflag |= HW_CS5;

  /*CHANGE*/
  if ((ds->info_cflag & CSIZE) == CS6)
    bs->cflag |= HW_CS6;

  /*CHANGE*/
  if ((ds->info_cflag & CSIZE) == CS7)
    bs->cflag |= HW_CS7;

  /*CHANGE*/
  if ((ds->info_cflag & CSIZE) == CS8)
    bs->cflag |= HW_CS8;

  /*CHANGE*/
  if (ds->info_cflag & CSTOPB)
    bs->cflag |= HW_CSTOPB;

  /*CHANGE*/
  if (ds->info_cflag & HUPCL)
    bs->cflag |= HW_HUPCL;

  /*CHANGE*/
  if (ds->info_cflag & PARENB)
    bs->cflag |= HW_PARENB;

  /*CHANGE*/
  if (ds->info_cflag & PARODD)
    bs->cflag |= HW_PARODD;

  /*CHANGE*/
  if (ds->info_cflag & LOBLK)
    bs->cflag |= HW_LOBLK;


  /*BAUD RATE TRANSLATIONS*/
  baudrate = ds->info_cflag & CBAUD;

  switch(baudrate)
  {

  case B0:
    bs->cflag |= HW_B0;
    break;

  case B50:
    bs->cflag |= HW_B50;
    break;

  case B75:
    bs->cflag |= HW_B75;
    break;

  case B110:
    bs->cflag |= HW_B110;
    break;

  case B134:
    bs->cflag |= HW_B134;
    break;

  case B150:
    bs->cflag |= HW_B150;
    break;

  case B200:
    bs->cflag |= HW_B200;
    break;

  case B300:
    bs->cflag |= HW_B300;
    break;

  case B600:
    bs->cflag |= HW_B600;
    break;

  case B900:
    bs->cflag |= HW_B0;
    break;

  case B1200:
    bs->cflag |= HW_B1200;
    break;

  case B1800:
    bs->cflag |= HW_B1800;
    break;

  case B2400:
    bs->cflag |= HW_B2400;
    break;

  case B3600:
    bs->cflag |= HW_B0;
    break;

  case B4800:
    bs->cflag |= HW_B4800;
    break;

  case B7200:
    bs->cflag |= HW_B0;
    break;

  case B9600:
    bs->cflag |= HW_B9600;
    break;

  case B19200:
    bs->cflag |= HW_B19200;
    break;

  case B38400:
    bs->cflag |= HW_B38400;
    break;

  case B57600:
    bs->cflag |= HW_B0;
    break;

  case B115200:
    bs->cflag |= HW_B0;
    break;

  case B230400:
    bs->cflag |= HW_B0;
    break;

  case B460800:
    bs->cflag |= HW_B0;
    break;

  default:
    bs->cflag |= HW_B0;
    break;
  }
}











