#if 0	/* Now defined in rascon.h */
typedef struct {
	unsigned char   rw_req;         /* Request type                 */
	unsigned char   rw_board;       /* Host Adapter board number    */
	unsigned char   rw_conc;        /* Concentrator number          */
	unsigned char   rw_reserved;    /* Reserved for expansion       */
	unsigned long   rw_addr;        /* Address in concentrator      */
	unsigned short  rw_size;        /* Read/write request length    */
	unsigned char   rw_data[128];   /* Data to read/write           */
} rw_t;

struct digi_info {
	unsigned long   info_bdnum;             /* Board number (0 based)  */
	unsigned long   info_ioport;            /* io port address         */
	unsigned long   info_physaddr;          /* memory address          */
	unsigned long   info_physsize;          /* Size of host mem window */
	unsigned long   info_memsize;           /* Amount of dual-port mem */
	                                        /* on board                */  
	                                                                                unsigned short  info_bdtype;            /* Board type              */
	unsigned short  info_nports;            /* number of ports         */
	char            info_bdstate;           /* board state             */ 
	char            info_reserved[7];       /* for future expansion    */ 
	
	/* Compatibility stuff */
	unsigned short firstchan;               /* First channel offset    */
};
                                        
struct digi_dinfo {
	unsigned long   dinfo_nboards;          /* # boards configured  */
	char            dinfo_reserved[12];     /* for future expansion */
	char            dinfo_version[16];      /* driver version       */
};
#endif

/* 
 * This structure holds data needed for the intelligent <--> nonintelligent 
 * DPA translation
 */
 
struct ni_info {
	int board;
	int channel;
	int dtr;
	int rts;
	int cts;
	int dsr;
	int ri;
	int dcd;
	int curtx;
	int currx;
//	char ofc;
//	char ifc;	
	unsigned short iflag;
	unsigned short oflag;
	unsigned short cflag;
	unsigned short lflag;

	unsigned int mstat;
	unsigned char hflow;

	unsigned char xmit_stopped;
	unsigned char recv_stopped;
};

#define RW_READ		1
#define RW_WRITE        2
#define DIGI_KME        ('e'<<8) | 98           /* Read/Write Host */

#define SUBTYPE         0007
#define T_PCXI          0000
#define T_PCXEM         0001
#define T_PCXE          0002
#define T_PCXR          0003
#define T_SP            0004
#define T_SP_PLUS       0005

#define T_HERC   0000
#define T_HOU    0001
#define T_LON    0002
#define T_CHA    0003

#define T_NEO	 0000
#define T_CLASSIC 0001

#define FAMILY          0070
#define T_COMXI         0000
#define	T_NI		0000
#define T_PCXX          0010
#define T_CX            0020
#define T_EPC           0030
#define T_PCLITE        0040
#define T_SPXX          0050
#define T_AVXX          0060
#define T_DXB           0070
#define T_A2K_4_8       0070

#define BUSTYPE         0700
#define T_ISABUS        0000
#define T_MCBUS         0100
#define T_EISABUS       0200
#define T_PCIBUS        0400

/* Board State Definitions */

#define BD_RUNNING      0x0
#define BD_REASON       0x7f
#define BD_NOTFOUND     0x1
#define BD_NOIOPORT     0x2
#define BD_NOMEM        0x3
#define BD_NOBIOS       0x4
#define BD_NOFEP        0x5
#define BD_FAILED       0x6
#define BD_ALLOCATED    0x7
#define BD_TRIBOOT      0x8
#define BD_BADKME       0x80

#define DIGI_AIXON      0x0400          /* Aux flow control in fep */

/* Ioctls needed for dpa operation */

#define DIGI_GETDD      ('d'<<8) | 248          /* get driver info      */
#define DIGI_GETBD      ('d'<<8) | 249          /* get board info       */
#define DIGI_GET_NI_INFO ('d'<<8) | 250		/* nonintelligent state snfo */

/* Other special ioctls */
#define DIGI_TIMERIRQ ('d'<<8) | 251		/* Enable/disable RS_TIMER use */
#define DIGI_LOOPBACK ('d'<<8) | 252		/* Enable/disable UART internal loopback */
