/*#include "dpacompat.h"*/

#ifndef KERNEL_VERSION
#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,0)
#define   B921600 0010007
#endif

#ifdef DIAGS
	/* When building standalone diagnostics disk images */
	#define MAXBOARDS 8
#else
	#define MAXBOARDS 4
#endif

#define MAXPORTSPERBOARD 8

#define DIGI_PCI_VENDOR_ID      0x114f
#define EXAR_PCI_VENDOR_ID	0x13a8

#define DIGI_CLASSIC_4_PCI_ID   0x0028
#define DIGI_CLASSIC_4_PCI      0
#define DIGI_CLASSIC_8_PCI_ID   0x0029
#define DIGI_CLASSIC_8_PCI      1
#define DIGI_NEOCLASSIC_8_OLD_PCI_ID	0x0158
#define DIGI_NEOCLASSIC_8_PCI_ID	0x00B1
#define	DIGI_NEOCLASSIC_8_PCI		2
#define DIGI_NEOCLASSIC_4_PCI_ID	0x00B0
#define	DIGI_NEOCLASSIC_4_PCI		3

/* Neo 2 port DB9 Univ PCI */
#define DIGI_NEOCLASSIC_2DB9_PCI_ID	0x00C8
#define	DIGI_NEOCLASSIC_2DB9_PCI		4

/* Neo 2 port DB9 Univ PCI Powered Ring Indicator*/
#define DIGI_NEOCLASSIC_2DB9PRI_PCI_ID	0x00C9
#define	DIGI_NEOCLASSIC_2DB9PRI_PCI		5

/* Neo 2 port RJ45 Univ PCI */
#define DIGI_NEOCLASSIC_2RJ45_PCI_ID	0x00CA
#define	DIGI_NEOCLASSIC_2RJ45_PCI		6

/* Neo 2 port RJ45 Univ PCI Powered Ring Indicator*/
#define DIGI_NEOCLASSIC_2RJ45PRI_PCI_ID	0x00CB
#define	DIGI_NEOCLASSIC_2RJ45PRI_PCI		7

#define TBUF_MAX		4096
#define TBUF_MASK		(TBUF_MAX-1)
#define MYFLIPLEN		TBUF_MAX

#define IOBASE_OFFSET           0x18
#define PLXIOBASE_OFFSET        0x14
#define PLXMEMBASE		0x20

#define XR17C158_PROTO_DEBUGLIGHTS	0x93

#ifndef SERIAL_TYPE_NORMAL
#define SERIAL_TYPE_NORMAL 1
#endif
#ifndef SERIAL_TYPE_CALLOUT
#define SERIAL_TYPE_CALLOUT 2
#endif
#ifndef SERIAL_TYPE_INFO
#define SERIAL_TYPE_INFO 3
#endif

#define IF_DOSMODE        0x8000          /* 16450-compatible errors */


#define DIGI_PLX9052	0x1
#define DIGI_XR17C158	0x2


struct board_struct {
	int type;
	int membase;
	char *re_map_membase;
	int numports;
	int flags;
	unsigned int pciset_iobase;
	unsigned int iobase;
	unsigned char irq;
	unsigned char irqpin;
	unsigned char io_type;
	unsigned int io_flags;
	unsigned int xmit_fifo_size;
	unsigned int dpastatus;
	unsigned int dpatype;
	int firstchan;
	int pci_bus;
	int pci_slot;
};

struct board_struct board[MAXBOARDS];

struct port_struct {
	unsigned int portnum;
	unsigned char cardnum;
	unsigned short portaddr;
	unsigned char uarttype;
	unsigned char irq;
	unsigned char io_type;
	unsigned int io_flags;
	unsigned int xmit_fifo_size;
	char *mem_portaddr;
};

/*#define MAXPORTS	32*/
/* Of course it would be better to make sure we don't exceed MAXPORTS
 * in the driver, but this should work... */
#define MAXPORTS	(MAXBOARDS*MAXPORTSPERBOARD)

struct port_struct ports[MAXPORTS];


#define	CPCI_GETNEXTPORTSTRUCT	0x7000


#define	CPCI_GETINFO	0x7000

#define CPCI_IO_MEM	1
#define CPCI_IO_PORT	0	

/* Register-specific flags that aid us in probing */
/* for devices					  */

#define CPCI_IOFLAGS_REGULAR_EXTREGS    0x1
#define CPCI_IOFLAGS_EXTENDED_EXTREGS	0x2

/* External function declarations */

extern void cpci_plx9052_enable_interrupts(int boardnum);
extern int  cpci_plx9052_config_board(int boardnum, int firstchan);
extern int cpci_xr17c158_config_board(int boardnum, int firstchan);

